using System.Text.Json;
using System.Text.Json.Serialization;

namespace ImmichToSlideshow.Models;

public record AppSettings(int AddDays,
                          string ArchivedTag,
                          string Company,
                          string ConnectionString,
                          string CurrentCommit,
                          string CurrentResultsDirectory,
                          string[] FilterTags,
                          string ImmichUploadDirectory,
                          string RandomResultsDirectory,
                          string SyncDirectory,
                          string URLs,
                          string[] WithOrigins,
                          string WorkingDirectoryName)
{

    public override string ToString()
    {
        string result = JsonSerializer.Serialize(this, AppSettingsSourceGenerationContext.Default.AppSettings);
        return result;
    }

}

[JsonSourceGenerationOptions(WriteIndented = true)]
[JsonSerializable(typeof(AppSettings))]
internal partial class AppSettingsSourceGenerationContext : JsonSerializerContext
{
}