using System.Text.Json;
using System.Text.Json.Serialization;

namespace ImmichToSlideshow.Models.Immich;

public record Tag([property: JsonPropertyName("id")] string Id,
                  [property: JsonPropertyName("userId")] string UserId,
                  [property: JsonPropertyName("value")] string OwnerId,
                  // [property: JsonPropertyName("createdAt")] DateTime CreatedAt,
                  // [property: JsonPropertyName("updatedAt")] DateTime UpdatedAt,
                  // [property: JsonPropertyName("color")] char Color,
                  // [property: JsonPropertyName("parentId")] string ParentId,
                  [property: JsonPropertyName("updateId")] string UpdateId)
{

    public override string ToString()
    {
        string result = JsonSerializer.Serialize(this, TagSourceGenerationContext.Default.Tag);
        return result;
    }

}

[JsonSourceGenerationOptions(WriteIndented = true)]
[JsonSerializable(typeof(Tag))]
internal partial class TagSourceGenerationContext : JsonSerializerContext
{
}

[JsonSourceGenerationOptions(WriteIndented = true)]
[JsonSerializable(typeof(Tag[]))]
internal partial class TagCollectionSourceGenerationContext : JsonSerializerContext
{
}