using ImmichToSlideshow.DependencyInjection;
using ImmichToSlideshow.Models;
using ImmichToSlideshow.RequestPipeline;

namespace ImmichToSlideshow;

public class Program
{

    public static void Main(string[] args)
    {
        WebApplicationBuilder webApplicationBuilder = WebApplication.CreateBuilder(args);
        _ = webApplicationBuilder.Configuration.AddUserSecrets<Program>();
        AppSettings appSettings = Models.Binder.AppSettings.Get(webApplicationBuilder.Configuration);
        _ = webApplicationBuilder.Services.AddControllers();
        _ = webApplicationBuilder.Services.AddServices(appSettings);
        WebApplication webApplication = webApplicationBuilder.Build();
        ILogger<Program>? logger = webApplication.Services.GetRequiredService<ILogger<Program>>();
        logger.LogInformation("Starting Web Application");
        _ = webApplication.InitializeCorsAndHttps(appSettings);
        _ = webApplication.MapControllers();
        _ = webApplication.InitializeDatabase();
        webApplication.Run();
    }

}