using ImmichToSlideshow.Models;

namespace ImmichToSlideshow.RequestPipeline;

public static class WebApplicationExtensions
{

    public static WebApplication InitializeDatabase(this WebApplication webApplication) =>
        // DBInitializer.Initialize(application.Configuration[DbConstants.DefaultConnectionStringPath]!);
        webApplication;

    public static WebApplication InitializeCorsAndHttps(this WebApplication webApplication, AppSettings appSettings)
    {
        _ = webApplication.UseCors(corsPolicyBuilder =>
            corsPolicyBuilder.WithOrigins(appSettings.WithOrigins).AllowAnyHeader().AllowAnyMethod());
        if (appSettings.URLs.Contains("https", StringComparison.InvariantCultureIgnoreCase))
        {
            _ = webApplication.UseHttpsRedirection();
            _ = webApplication.UseHsts();
        }
        return webApplication;
    }

}